var LiamW = window.LiamW || {};
LiamW.PostMacros = LiamW.PostMacros || {};

!function ($, window, document) {
	LiamW.PostMacros.macroInserter = {
		macros: {},
		metaDataHandlers: {
			"LiamW\\PostMacros:ThreadTitle": function (value, ed) {
				var $titleInput = ed.$oel.closest('form').find('input[name=title]').first();

				if ($titleInput)
				{
					$titleInput.val(value);
				}
			}
		},

		editorStart: function (a, b) {
			LiamW.PostMacros.macroInserter.processMacros();
			LiamW.PostMacros.macroInserter.registerButtonCommands();
		},

		processMacros: function () {
			try
			{
				LiamW.PostMacros.macroInserter.macros = $.parseJSON($('.js-lwPostMacros-macros').first().html());
			} catch (e)
			{

				LiamW.PostMacros.macroInserter.macros = [];
				console.error("Unable to process macros:", e);
			}
		},

		registerButtonCommands: function () {
			$.FE.DefineIcon('lwPostMacrosInsert', {NAME: "bolt"});
			$.FE.RegisterCommand('lwPostMacrosInsert', {
				type: 'dropdown',
				title: 'Insert Macro',
				undo: true,
				focus: true,
				html: function () {
					var html = '<ul class="fr-dropdown-list">';
					LiamW.PostMacros.macroInserter.macros.forEach(function (macro, k) {
						html += '<li><a class="fr-command" data-cmd="lwPostMacrosInsert" data-param1="' + k + '">' + macro['title'] + '</a></li>';
					});
					html += '</ul>';
					return html;
				},
				callback: function (cmd, val) {
					var ed = this;
					if (LiamW.PostMacros.macroInserter.macros[val]['hasTokens'])
					{
						XF.ajax("get", XF.canonicalizeUrl("index.php?account/macros/tokens"), {
							"macro_id": LiamW.PostMacros.macroInserter.macros[val]['macro_id'],
							"action_url": ed.$oel.closest('form').attr("action"),
							"editor_id": ed.$oel.attr('name')
						}, function (data, status, xhr) {
							XF.setupHtmlInsert(data.html, function ($html, container, onComplete) {
								var overlay = new XF.Overlay(XF.getOverlayHtml({
									html: $html,
									title: container.title || container.h1
								}));
								overlay.on('overlay:hidden', function () {
									overlay.destroy();
								});

								overlay.show();
							});
						});
					} else
					{
						console.log(XF.canonicalizeUrl('index.php?account/macros/get'));
						XF.ajax("get", XF.canonicalizeUrl('index.php?account/macros/get'), {
							"macro_id": LiamW.PostMacros.macroInserter.macros[val]['macro_id'],
							"action_url": ed.$oel.closest('form').attr("action")
						}, function (data, status, xhr) {
							LiamW.PostMacros.macroInserter.processMacroResponse(data.macro, ed);
						});
					}
				}
			});
		},

		processMacroResponse: function (macro, ed) {
			ed.html.insert(macro.html_content);

			if (typeof macro._metadata !== 'undefined')
			{
				for (var id in macro._metadata)
				{
					if (!macro._metadata.hasOwnProperty(id))
					{
						continue;
					}

					var metadataValue = macro._metadata[id];

					if (metadataValue != null && LiamW.PostMacros.macroInserter.metaDataHandlers.hasOwnProperty(id) && typeof LiamW.PostMacros.macroInserter.metaDataHandlers[id] === 'function')
					{
						console.debug("Calling metadata handler for: " + id);
						LiamW.PostMacros.macroInserter.metaDataHandlers[id](metadataValue, ed);
					} else if (metadataValue != null)
					{
						console.debug("Calling default metadata handler for: " + id);
						LiamW.PostMacros.macroInserter.handleOtherMetadata(ed, id, metadataValue);
					}
				}
			}

			if (macro.auto_submit)
			{
				let form = ed.el.closest('form');
				$(form).submit()
			}
		},

		handleOtherMetadata: function (ed, id, value) {

			var $form = ed.$oel.closest('form');
			var $inputName = "macro_metadata[" + id + "]";

			if (typeof value == "object")
			{
				for (var subValueId in value)
				{
					if (!value.hasOwnProperty(subValueId))
					{
						continue;
					}

					$('<input type="hidden" />').attr('name', $inputName + "[" + subValueId + "]").val(value[subValueId] ? 1 : 0).appendTo($form);
				}

			} else
			{
				$('<input type="hidden" />').attr('name', $inputName).val(value).appendTo($form);
			}
		}
	};

	LiamW.PostMacros.MacroTokensHandler = XF.Element.newHandler({

		options: {
			'editorId': null
		},

		editorContainer: null,

		init: function () {
			this.editorContainer = $('textarea[name="' + this.options.editorId + '"]');
			if (typeof this.editorContainer == 'undefined')
			{
				console.error("Post Macros: Cannot find editor container!");
			} else
			{
				this.$target.on('ajax-submit:complete', XF.proxy(this, 'handleResponse'));
			}
		},

		handleResponse: function (e, data) {
			if (data.status === "ok")
			{
				LiamW.PostMacros.macroInserter.processMacroResponse(data.macro, XF.getEditorInContainer(this.editorContainer).ed);
			}
		}

	});

	LiamW.PostMacros.QuickReplyExtension = {
		__backup: {
			'afterSubmit': '_lwMacrosAfterSubmit'
		},

		afterSubmit: function (e, data) {
			this._lwMacrosAfterSubmit(e, data);

			if (e.isDefaultPrevented())
			{
				$("input[name^='macro_metadata']").each(function (k, v) {
					v.remove();
				})
			}
		}
	};

	XF.Element.extend('quick-reply', LiamW.PostMacros.QuickReplyExtension);
	XF.Element.register('macro-tokens', 'LiamW.PostMacros.MacroTokensHandler');
	$(document).one('editor:start', LiamW.PostMacros.macroInserter.editorStart);
}(jQuery, window, document);