<?php

namespace LiamW\PostMacros\Admin\View\Macros;

use XF\Mvc\View;

class Edit extends View
{
	public function renderHtml()
	{
		$metadataGroupHandlers = \XF::repository('LiamW\PostMacros:Macro')->getMetaDataGroupHandlers();
		$metadataHandlersGrouped = \XF::repository('LiamW\PostMacros:Macro')->getMetaDataHandlersGrouped();

		$renderedMetadataTemplates = [];

		/** @var \LiamW\PostMacros\MetaData\Handler\AbstractHandler $metadataHandler */
		foreach ($metadataHandlersGrouped as $contentType => $metadataHandlers)
		{
			$renderedMetadataTemplates[$contentType] = [
				'label' => $metadataGroupHandlers[$contentType]->getGroupLabel(),
				'templates' => []
			];

			foreach ($metadataHandlers AS $metadataHandler)
			{
				if (isset($this->params['macro']->metadata[$metadataHandler->getShortName()]))
				{
					$metadataHandler->setValue($this->params['macro']->metadata[$metadataHandler->getShortName()]);
				}
				$renderedMetadataTemplates[$contentType]['templates'][] = $metadataHandler->renderInput($this);
			}
		}

		$this->params['renderedMetadataTemplatesGrouped'] = $renderedMetadataTemplates;
	}
}