<?php

namespace LiamW\PostMacros\AdminSearch;

use XF\AdminSearch\AbstractHandler;
use XF\Mvc\Entity\AbstractCollection;
use XF\Mvc\Entity\Entity;

class GlobalMacro extends AbstractHandler
{
	public function getDisplayOrder()
	{
		return 50;
	}

	/**
	 * @param string $text
	 * @param integer $limit
	 * @param array $previousMatchIds
	 *
	 * @return AbstractCollection
	 */
	public function search($text, $limit, array $previousMatchIds = [])
	{
		$finder = $this->app->finder('LiamW\PostMacros:Macro');
		$conditions = [
			['type', 'global'],
			[$finder->columnUtf8('title'), 'like', $finder->escapeLike($text, '%?%')]
		];

		if ($previousMatchIds)
		{
			$conditions[] = ['macro_id', $previousMatchIds];
		}

		return $finder->where($conditions)->fetch($limit);
	}

	public function getTemplateData(Entity $record)
	{
		/** @var \XF\Mvc\Router $router */
		$router = $this->app->container('router.admin');

		return [
			'link' => $router->buildLink('post-macros/edit', $record),
			'title' => $record->title
		];
	}
}