<?php

namespace LiamW\PostMacros\ChangeCategory;

class Thread extends AbstractHandler
{
    /**
     * @var string
     */
    protected $contentType = 'thread';

    /**
     * @var string
     */
    protected $shortName = 'LiamW\PostMacros:Thread';

    /**
     * @return mixed
     */
    protected function setCategory()
    {
        $nodeRepo = \XF::repository('XF:Node');
        $nodeTree = $nodeRepo->createNodeTree($nodeRepo->getFullNodeList());
        return $nodeTree->filter(null, function($id, $node, $depth, $children, $tree)
        {
            return ($children || $node->node_type_id == 'Forum');
        });
    }

    /**
     * @return mixed|\XF\Phrase
     */
    public function label()
    {
        return \XF::phrase('node');
    }

    /**
     * @return int|mixed
     */
    public function testIfCategoryExist()
    {
        return $this->finder('xf:forum')
            ->where('node_id', $this->categoryId)
            ->total();
    }
}