<?php

namespace LiamW\PostMacros\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int macro_id
 * @property int user_id
 *
 * RELATIONS
 * @property \XF\Entity\User User
 * @property \LiamW\PostMacros\Entity\Macro Macro
 */
class GlobalMacroEnrolment extends Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_liamw_post_macros_global_enrolment';
		$structure->primaryKey = ['macro_id', 'user_id'];
		$structure->columns = [
			'macro_id' => ['type' => self::UINT, 'required' => true],
			'user_id' => ['type' => self::UINT, 'required' => true]
		];
		$structure->relations = [
			'User' => [
				'entity' => 'XF:User',
				'type' => self::TO_ONE,
				'conditions' => 'user_id'
			],
			'Macro' => [
				'entity' => 'LiamW\PostMacros:Macro',
				'type' => self::TO_ONE,
				'conditions' => 'macro_id'
			]
		];

		return $structure;
	}
}