<?php

namespace LiamW\PostMacros\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int macro_id
 * @property int user_id
 * @property bool can_write
 * @property bool enrolled
 *
 * RELATIONS
 * @property \XF\Entity\User User
 */
class MacroSharing extends Entity
{
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_liamw_post_macros_shared';
		$structure->primaryKey = ['macro_id', 'user_id'];
		$structure->columns = [
			'macro_id' => ['type' => self::UINT, 'required' => true],
			'user_id' => ['type' => self::UINT, 'required' => true, 'writeOnce' => true],
			'can_write' => ['type' => self::BOOL, 'default' => false],
			'enrolled' => ['type' => self::BOOL, 'default' => false]
		];
		$structure->relations = [
			'User' => [
				'entity' => 'XF:User',
				'type' => self::TO_ONE,
				'conditions' => 'user_id'
			]
		];

		return $structure;
	}
}