<?php

namespace LiamW\PostMacros\Finder;

use XF\Mvc\Entity\Finder;

class Macro extends Finder
{
	public function globalMacros()
	{
		$this->where('type', 'global');

		return $this;
	}

	public function userMacros()
	{
		$this->where('type', 'user');

		return $this;
	}

	public function orderTitle($direction = 'ASC')
	{
		$expression = $this->columnUtf8('title');
		$this->order($expression, $direction);

		return $this;
	}

	public function searchTitle($match, $prefixMatch = false)
	{
		if ($match)
		{
			$this->where(
				$this->columnUtf8('title'),
				'LIKE',
				$this->escapeLike($match, $prefixMatch ? '?%' : '%?%')
			);
		}

		return $this;
	}
}