<?php

namespace LiamW\PostMacros\MetaData\Handler;

use LiamW\PostMacros\Entity\Macro;
use XF\Entity\Thread;
use XF\Mvc\Entity\Entity;
use XF\Mvc\View;

class ThreadPrefix extends AbstractHandler
{
	protected $shortName = 'LiamW\PostMacros:ThreadPrefix';

	protected function renderMetaDataInput(View $view, $inputName)
	{
		return $view->renderTemplate('public:liamw_postmacros_metadata_template_thread_prefix', [
			'value' => $this->value,
			'inputName' => $inputName,
			'threadPrefixes' => \XF::app()->finder('XF:ThreadPrefix')
				->order('materialized_order')
				->fetch()->groupBy('prefix_group_id')
		]);
	}

	protected function renderMetaData(View $view)
	{
		return $view->renderTemplate('public:liamw_postmacros_metadata_view_thread_prefix', [
			'prefix' => \XF::app()->finder('XF:ThreadPrefix')->whereId($this->value)
				->order('materialized_order')
				->fetchOne()
		]);
	}

	public function getFilterType()
	{
		return '?uint';
	}

	public function getMetaDataGroup()
	{
		return 'thread';
	}

	protected function verifyMetadataValue(Macro $macro, &$newValue)
	{
		if ($newValue === 0)
		{
			$newValue = null;
		}
		return true;
	}

	protected function processInternal(Entity $entity, $value)
	{
		/** @var Thread $entity */
		if ($entity->canEdit())
		{
			$entity->prefix_id = $value;
		}
	}
}