<?php

namespace LiamW\PostMacros\MetaData\Handler;

use LiamW\PostMacros\Entity\Macro;
use XF\Entity\Thread;
use XF\Mvc\Entity\Entity;
use XF\Mvc\View;

class ThreadTitle extends AbstractHandler
{
	protected $shortName = 'LiamW\PostMacros:ThreadTitle';

	protected function renderMetaDataInput(View $view, $inputName)
	{
		return $view->renderTemplate('public:liamw_postmacros_metadata_template_thread_title', [
			'value' => $this->value,
			'inputName' => $inputName
		]);
	}

	protected function renderMetaData(View $view)
	{
		return $view->renderTemplate('public:liamw_postmacros_metadata_view_thread_title', [
			'value' => $this->value
		]);
	}

	public function getFilterType()
	{
		return '?str';
	}

	public function getMetaDataGroup()
	{
		return 'thread';
	}

	protected function verifyMetadataValue(Macro $macro, &$newValue)
	{
		if ($newValue === "")
		{
			$newValue = null;
		}

		return true;
	}

	protected function processInternal(Entity $entity, $value)
	{
		/** @var Thread $entity */
		if ($entity->canEdit())
		{
			$entity->title = $value;
		}
	}
}