<?php

namespace LiamW\PostMacros\XF\Admin\Controller;

use XF\Mvc\ParameterBag;

class Permission extends XFCP_Permission
{
	public function actionGlobalMacros(ParameterBag $params)
	{
		if ($params->macro_id)
		{
			return $this->getGlobalMacroPermissionPlugin()->actionList($params);
		}
		else
		{
			$macros = $this->finder('LiamW\PostMacros:Macro')->globalMacros()->fetch();

			$viewParams = [
				'macros' => $macros
			];
			return $this->view('LiamW\PostMacros:Permission\GlobalMacroOverview', 'liamw_postmacros_permission_globalmacro_overview', $viewParams);
		}
	}

	public function actionGlobalMacrosEdit(ParameterBag $params)
	{
		$this->assertAdminPermission('node');

		return $this->getGlobalMacroPermissionPlugin()->actionEdit($params);
	}

	public function actionGlobalMacrosSave(ParameterBag $params)
	{
		$this->assertAdminPermission('node');

		return $this->getGlobalMacroPermissionPlugin()->actionSave($params);
	}

	protected function getGlobalMacroPermissionPlugin()
	{
		/** @var \LiamW\PostMacros\ControllerPlugin\GlobalMacroPermission $plugin */
		$plugin = $this->plugin('LiamW\PostMacros:GlobalMacroPermission');

		return $plugin;
	}
}