<?php

namespace LiamW\PostMacros\XF\Entity;


class Post extends XFCP_Post
{
    protected $redirection = false;
    protected function _preSave()
    {
        $message = $this->message;
        $pattern = "/\{=\+(.*?)\}/";
        preg_match('/\{=\+(?P<username>.+)\}/', $message, $matches);
        $visitor = \XF::visitor();
        $thread = $this->Thread;
        if(!empty($matches) && $thread->first_post_id != $this->post_id && $visitor->hasPermission('liamw_postmacros', 'another_account'))
        {
            /** @var \XF\Entity\User $user */
            $user = $this->finder('XF:User')->where('username', '=', $matches['username'])->fetchOne();
            if(!empty($user))
            {
                $this->user_id = $user->user_id;
                $this->username = $user->username;
            }
            $this->message = preg_replace($pattern, '',$message);
        }
        elseif(!empty($matches))
        {
            $this->message = preg_replace($pattern, '',$message);
        }
        $handlerChangeCategory = $this->getMacroRepository()->getChangeTypeHandler('LiamW\PostMacros:Thread', $this->message);
        if($handlerChangeCategory->getIdCategory() &&
            $thread->first_post_id != $this->post_id &&
            $handlerChangeCategory->testIfCategoryExist() &&
            $handlerChangeCategory->canChangeCategory()
        )
        {
            $thread->node_id = $handlerChangeCategory->getIdCategory();
            $thread->save();
            $this->redirection = true;
        }
        $this->message = $handlerChangeCategory->removeCategoryId();

        return parent::_preSave();
    }
    public function getRedirection()
    {
        return $this->redirection;
    }
    /**
     * @return \LiamW\PostMacros\Repository\Macro|\XF\Mvc\Entity\Repository
     */
    protected function getMacroRepository()
    {
        return $this->repository('LiamW\PostMacros:Macro');
    }
}