<?php

namespace LiamW\PostMacros\XF\Entity;

class User extends XFCP_User
{
	public function canUseMacros(&$error = null)
	{
		if (!$this->hasPermission('liamw_postmacros', 'use'))
		{
			return false;
		}

		return true;
	}

	/**
	 * @since 5.1.0
	 *
	 * @param string|null $error
	 *
	 * @return bool
	 */
	public function canCreateMacro(&$error = null)
	{
		if (!$this->canUseMacros($error) || !$this->hasPermission('liamw_postmacros', 'create'))
		{
			return false;
		}

		$macroCount = $this->finder('LiamW\PostMacros:Macro')->where('user_id', $this->user_id)->total();

		$maxMacros = $this->hasPermission('liamw_postmacros', 'maximum_macros');
		if ($maxMacros > -1 && $macroCount >= $maxMacros)
		{
			$error = \XF::phraseDeferred('liamw_postmacros_you_have_exceeded_the_maximum_allowed_number_of_macros');

			return false;
		}

		return true;
	}
}