<?php

namespace LiamW\PostMacros\XF\Pub\Controller;

use XF\Mvc\ParameterBag;

class Thread extends XFCP_Thread
{
	protected function finalizeThreadReply(\XF\Service\Thread\Replier $replier)
	{
		parent::finalizeThreadReply($replier);

		$this->repository('LiamW\PostMacros:Macro')->getMetaDataGroupHandler('thread')->processMetadata($replier->getThread(), $this);
	}

    /**
     * @param \XF\Entity\Thread $thread
     * @param $lastDate
     * @return \XF\Mvc\Reply\Redirect|\XF\Mvc\Reply\View
     */
    protected function getNewPostsReply(\XF\Entity\Thread $thread, $lastDate)
    {
        $view = parent::getNewPostsReply($thread, $lastDate);
        if($view instanceof \XF\Mvc\Reply\View)
        {
            if($view->getParam('posts') && $view->getParam('posts')->last()->getRedirection())
            {
                return $this->redirect($this->buildLink('threads', $view->getParam('thread')));
            }
        }
        return $view;
    }
}